// C Source File
// Created 27/07/2003; 12:03:54

#include "mkcomplib.h"

/*===============================================================================================
== Write the decompressed datas
=================================================================================================
== data : pointer of the data to decompress
== length : length of the data to decompress
== dest : address of writing
== tree : TREE structure of the huffmann tree
== offset : bit position of reading
== root : position of the root of the tree
=================================================================================================
== return the pointer of the last caracter written
===============================================================================================*/
unsigned char * write_decomp(unsigned char * data, unsigned short length, unsigned char * dest,
                TREE * tree, unsigned char offset, unsigned char root) {
  unsigned short no;
  
  offset--;
  while ((length--)>0) {
        
    no=root;
tree:
    if ((offset++)==7) {
      offset=0;
      data++;
    }
    if ((*data)&(1<<offset)) {  //1 : right
      if (tree[no].node_right) { //1 : it's a mode, 0 a caracter
        no=tree[no].right_branch;
      } else {
        *(dest++)=tree[no].right_branch;  //write the caracter
        continue;
      }
    } else {  //go on the left
      if (tree[no].node_left) { // a node
        no=tree[no].left_branch;
      } else {
        *(dest++)=tree[no].left_branch;
        continue;
      }
    }
    goto tree;
  }
  
  return dest;
  
}
