// C Header File
// Created 06/10/2003; 19:14:17

//#define _GENERIC_ARCHIVE

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#include <tigcclib.h>

#include "complib.h"
#include "huff_mk_tree.h"
#include "huff_comp.h"
#include "huff_dcomp.h"

#define NB_COMP_ERR     8

extern CompErr study_zip(unsigned char * data, unsigned short length,
                         TREE * * tree, short * nL, unsigned short * comp_len, short * offset,
                         BOOL temp);
extern CompErr mk_zip(unsigned char * data, unsigned short length, unsigned char * data_dest,
                      TREE * tree, short nL, unsigned short comp_len, short offset, unsigned char type, BOOL temp);

extern CompErr study_dzip(unsigned char * data, unsigned short length,
                   TREE * * tree, short * nL, unsigned short * file_len, short * byte_offset, short * bit_offset);
extern CompErr mk_dzip(unsigned char * data, unsigned char * dest, const unsigned char * str_tag, unsigned char tag_length,
                       TREE * tree, short nL, unsigned short file_len, short byte_offset, short bit_offset);
                
extern CompErr study_komp(unsigned char * data, unsigned short length,
                          unsigned short * * stat, TREE * * tree, unsigned short * comp_len, short * offset, short * nb1, short * nb2, short * mode,
                          BOOL temp);
extern CompErr mk_komp(unsigned char * data, unsigned short length, unsigned char * dest,
                       unsigned short * stat, TREE tree[], unsigned short comp_len, short offset, short nb1, short nb2, short mode,
                       unsigned char type, BOOL temp);

extern CompErr study_dkomp(unsigned char * data, unsigned short length,
                           TREE * * tree, unsigned short * file_len, unsigned short * nL);
extern CompErr mk_dkomp(unsigned char * data, unsigned char * dest, const unsigned char * str_tag, unsigned char tag_length,
                        TREE * tree, unsigned short file_len, unsigned short nL);


