// C Header File
// Created 27/07/2003; 12:17:50

#ifndef __huff_mk_tree__
#define __huff_mk_tree__

typedef struct {
  unsigned char right_branch;  //right branch : 0
  unsigned char left_branch;   //left branch : 1
  unsigned char father;
  unsigned char node_right:1, node_left:1,  //determinate if caracter or node
                node:1;     //O if it's the left branch, else 1
} TREE;

/*===============================================================================================
== creation of the tree (make its nodes) with the stats
=================================================================================================
== stat : table of filled stats
== NODE : table of nodes to fill
=================================================================================================
== return the root position
===============================================================================================*/
extern void mk_tree(unsigned short stat[], TREE tree[], unsigned short nL);

#endif
